-- Arctic / Admir --
-- CRYSIS 2D VERSION 2 --

-- C2D Settings
c2d_maxenergy = 100 -- above and below 100 will lead to bug! (100 is default)
c2d_defaultnanoarmor = 50

c2d_nanomenu = { "Nanosuit V2 Menu" , "Engage Cloak" , "Maximum Speed" , "Maximum Armor" , "Maximum Strength"}
c2d_cet = "Cloak Engaged"
c2d_mspt = "Maximum Speed"
c2d_mat = "Maximum Armor"
c2d_mst = "Maximum Strength"

-- Additional Settings 
parse("debuglua 0") -- clear console, no addhook spam message; hate them >:(

--
function initArray(m,v)
	local array = {}
	for i = 1, m do
		array[i]=v
	end
	return array
end

c2d_mode = initArray(32,0)
c2d_invisible = initArray(32,0)
c2d_speed = initArray(32,0)
c2d_defense = initArray(32,0)
c2d_strength = initArray(32,0)
c2d_energy = initArray(32,50)
-- c2d_delay = initArray(32,0)

c2d_screen1 = initArray(32,0)
c2d_screen2 = initArray(32,0)

c2d_backup_armor = initArray(32,c2d_defaultnanoarmor)

addhook("ms100","c2d_ms100")
addhook("menu","c2d_menu")
addhook("die","c2d_die")
addhook("hit","c2d_hit")
addhook("attack","c2d_attack")
addhook("attack2","c2d_attack2")
addhook("serveraction","c2d_action")
addhook("buy","c2d_buy")
addhook("startround","c2d_startround")
addhook("spawn","c2d_spawn")
addhook("move","c2d_move")
addhook("second","c2d_second")

--

function c2d_spawn(id)

	parse('hudtxt2 '..id..' 2 "166166166(( Energy ))" 295 365')
	parse("setarmor "..id.." "..c2d_defaultnanoarmor)

	if game("sv_gamemode") == "4" then
		msg("255000000PLEASE CHANGE GAMEMODE INSTEAD USING ZOMBIES! @C")
	end
end

function c2d_attack2(id,mode)
	if player(id,"weapontype") == 50 then
		if (c2d_invisible[id] > 0) then
			parse("setarmor "..id.." "..c2d_backup_armor[id])
			c2d_energy[id] = 0
			c2d_mode[id] = 0
			c2d_invisible[id] = 0
			freeimage(c2d_screen1[id])
			freeimage(c2d_screen2[id])
		end

		if (c2d_strength[id] > 0) then
			c2d_energy[id] = c2d_energy[id] - 50
		end
	end
end

function c2d_attack(id)
	if (c2d_strength[id] > 0) then
		c2d_energy[id] = c2d_energy[id] - 5
	end

	if (c2d_invisible[id] > 0) then
		parse("setarmor "..id.." "..c2d_backup_armor[id])
		c2d_energy[id] = 0
		c2d_mode[id] = 0
		c2d_invisible[id] = 0
		freeimage(c2d_screen1[id])
		freeimage(c2d_screen2[id])
	end
end

function c2d_action(id,action)
	if (action == 1) then

		if player(id,"health") > 0 and (c2d_mode[id] == 0) then
			menu(id,""..c2d_nanomenu[1]..","..c2d_nanomenu[2]..","..c2d_nanomenu[3]..","..c2d_nanomenu[4]..","..c2d_nanomenu[5].."")

		else
			c2d_invisible[id] = 0
			c2d_mode[id] = 0
			c2d_speed[id] = 0
			c2d_strength[id] = 0
			c2d_defense[id] = 0
			parse("setarmor "..id.." "..c2d_backup_armor[id])
			parse("speedmod "..id.." 0")
			freeimage(c2d_screen1[id]) 
			freeimage(c2d_screen2[id])
			

			-- Ignored when dies, don't do anything when health is < '0'
		end

	elseif (action == 3) then
		if (c2d_mode[id] == 1) then
			c2d_invisible[id] = 0
			c2d_mode[id] = 0
			c2d_speed[id] = 0
			c2d_strength[id] = 0
			parse("setarmor "..id.." "..c2d_backup_armor[id])
			c2d_defense[id] = 0
			parse("speedmod "..id.." 0")
			freeimage(c2d_screen1[id])
			freeimage(c2d_screen2[id])
		end
			
	end
end

function c2d_second()
	local i
	for i = 1,32 do
		if player(i,"exists") then

			if (c2d_invisible[i] == 1) then
				c2d_energy[i] = c2d_energy[i] - 1
			end
		end
	end
end

function c2d_menu(id,title,key)
	if (title == ""..c2d_nanomenu[1].."") then
		if (key == 1) then
			if (c2d_invisible[id] == 0 and c2d_mode[id] == 0) then
				c2d_backup_armor[id] = player(id,"armor")
				c2d_invisible[id] = 1
				c2d_mode[id] = 1
				msg2(id,"255255255"..c2d_cet.."@C")
				parse("sv_sound2 "..id.." \"c2d/nanosuit_cloak.wav\"")
				parse("setarmor "..id.." 206")

				c2d_screen1[id] = image("gfx/c2d/suiton.bmp",0,0,132+id,id)
				imageblend(c2d_screen1[id],1)
				imagealpha(c2d_screen1[id],0.7)
			end

		elseif (key == 2) then
			if (c2d_speed[id] == 0 and c2d_mode[id] == 0) then
				c2d_speed[id] = 1
				c2d_mode[id] = 1
				msg2(id,"000000255"..c2d_mspt.."@C")
				parse("sv_sound2 "..id.." \"c2d/nanosuit_speed.wav\"")
				parse("speedmod "..id.." 25")

				c2d_screen1[id] = image("gfx/c2d/suiton.bmp",0,0,132+id,id)
				imageblend(c2d_screen1[id],1)
				imagealpha(c2d_screen1[id],1)
				imagecolor(c2d_screen1[id],0,0,150)
				c2d_screen2[id] = image("gfx/c2d/suitglare.bmp",0,0,132+id,0)
				imageblend(c2d_screen2[id],1)
				imagecolor(c2d_screen2[id],0,0,225)
			end
	
		elseif (key == 3) then
			if (c2d_defense[id] == 0 and c2d_mode[id] == 0) then
				c2d_defense[id] = 1
				c2d_mode[id] = 1
				msg2(id,"000255000"..c2d_mat.."@C")
				parse("sv_sound2 "..id.." \"c2d/nanosuit_armor.wav\"")
				parse("speedmod "..id.." -5")

				c2d_screen1[id] = image("gfx/c2d/suiton.bmp",0,0,132+id,id)
				imageblend(c2d_screen1[id],1)
				imagealpha(c2d_screen1[id],0.7)
				imagecolor(c2d_screen1[id],0,150,0)
				c2d_screen2[id] = image("gfx/c2d/suitglare.bmp",0,0,132+id,0)
				imageblend(c2d_screen2[id],1)
				imagecolor(c2d_screen2[id],0,225,0)
			end

		elseif (key == 4) then
			if (c2d_strength[id] == 0 and c2d_mode[id] == 0) then
				c2d_backup_armor[id] = player(id,"armor")
				c2d_strength[id] = 1
				c2d_mode[id] = 1
				msg2(id,"255000000"..c2d_mst.."@C")
				parse("setarmor "..id.." 0")
				parse("sv_sound2 "..id.." \"c2d/nanosuit_strength.wav\"")

				c2d_screen1[id] = image("gfx/c2d/suiton.bmp",0,0,132+id,id)
				imageblend(c2d_screen1[id],1)
				imagealpha(c2d_screen1[id],0.7)
				imagecolor(c2d_screen1[id],150,0,0)
				c2d_screen2[id] = image("gfx/c2d/suitglare.bmp",0,0,132+id,0)
				imageblend(c2d_screen2[id],1)
				imagecolor(c2d_screen2[id],225,0,0)
			end
		end
	end
end

function c2d_move(id,x,y,walk)
	if (c2d_speed[id] == 1) then
		c2d_energy[id] = c2d_energy[id] - 0.75
	end

	if (c2d_invisible[id] == 1) then
		if (walk == 0) then 
			c2d_energy[id] = c2d_energy[id] - 0.55

		elseif (walk == 1) then 
			c2d_energy[id] = c2d_energy[id] - 0.25
		end
	end
end

function c2d_hit(id,source,weapon,hpdmg,apdmg)

	if (c2d_defense[id] == 1) then
		c2d_energy[id] = c2d_energy[id] - apdmg / 3.5
		parse("shake "..id.." 3")
		parse("sv_sound2 "..id.." \"c2d/nanosuit_hitted1.wav\"")

		if (c2d_energy[id] < 1) then
			parse("sv_sound2 "..id.." \"c2d/nanosuit_energy.wav\"")
		end

		if (c2d_strength[source] == 1) then
			c2d_energy[id] = c2d_energy[id] - apdmg * 0.75
			parse("shake "..id.." 7")
		return 1
		end
	return 1
	end

	if (c2d_strength[source] == 1) then
		local strdmg = weapon + weapon
			if player(id,"health") - strdmg > 0 then
				parse("sethealth "..id.." " ..player(id,"health") - strdmg / 1.5)
				parse("setarmor "..id.." "..player(id,"armor") - strdmg / 3)
			return 1
			end

		if (weapon == 50) then
			parse('customkill '..source..' "Strength Power" '..id)
			c2d_energy[source] = 0
		else
			if (c2d_defense[id] > 0) then
				-- Resist to Strength Power
			c2d_energy[source] = 0
			end
		end
	end
end

function c2d_ms100()
	local i
	for i = 1,32 do
		if (player(i,"exists")) then

			if (c2d_mode[i] == 0 and player(i,"health") > 0) then
				c2d_energy[i] = c2d_energy[i] + 2
				if (c2d_energy[i] >= c2d_maxenergy) then
					c2d_energy[i] = c2d_maxenergy
				end
			end

			if (player(i,"health") > 0) then
				if (c2d_energy[i] < 1) then
					c2d_invisible[i] = 0
					c2d_speed[i] = 0
					c2d_strength[i] = 0
					c2d_defense[i] = 0
					c2d_mode[i] = 0
					parse("setarmor "..i.." "..c2d_backup_armor[i])
					parse("speedmod "..i.." 0")
					freeimage(c2d_screen1[i])
					freeimage(c2d_screen2[i])
				end
			end
		c2d_hud(i)
		end
	end
end
	
function c2d_die(id,killer,weapon)
	if (c2d_mode[id] == 1) then
		freeimage(c2d_screen1[id])
		freeimage(c2d_screen2[id])
	end

	c2d_invisible[id] = 0
	c2d_defense[id] = 0
	c2d_speed[id] = 0
	c2d_mode[id] = 0
	c2d_strength[id] = 0
	c2d_energy[id] = 0

	return 1
end

function c2d_buy(id,weapon)
	if (weapon == 57 or weapon == 58) then
		return 1
	end
end

function c2d_startround()
	for i = 1, 32 do
		if player(i,"exists") then
			c2d_invisible[i] = 0
			c2d_defense[i] = 0
			c2d_speed[i] = 0
			c2d_mode[i] = 0
			c2d_strength[i] = 0
			c2d_energy[i] = 0
			freeimage(c2d_screen1[i])
			freeimage(c2d_screen2[i])
		end
	end
end

function c2d_hud(id)

	local id
	for id = 1,32 do
		if player(id,"exists") then

			-- Energy update hud
			if (c2d_energy[id] == 100) then
				parse('hudtxt2 '..id..' 1 "000255000[ |||||||||||||||||||| ]" 290 385')
			elseif (c2d_energy[id] >=90) then
				parse('hudtxt2 '..id..' 1 "000255000[ |||||||||||||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 80) then
				parse('hudtxt2 '..id..' 1 "000255000[ ||||||||||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 70) then
				parse('hudtxt2 '..id..' 1 "255255000[ ||||||||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 60) then
				parse('hudtxt2 '..id..' 1 "255255000[ ||||||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 50) then
				parse('hudtxt2 '..id..' 1 "255155000[ ||||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 40) then
				parse('hudtxt2 '..id..' 1 "255100000[ ||||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 30) then
				parse('hudtxt2 '..id..' 1 "255050000[ ||||| 	]" 290 385')
			elseif (c2d_energy[id] >= 20) then
				parse('hudtxt2 '..id..' 1 "255000000[ ||| 	]" 290 385')
			elseif (c2d_energy[id] >= 10) then
				parse('hudtxt2 '..id..' 1 "255000000[ |	 	]" 290 385')
			elseif (c2d_energy[id] >= 0) then
				parse('hudtxt2 '..id..' 1 "255000000[ 	 	]" 290 385')
			end
	
			if (c2d_invisible[id] == 1) then
				parse('hudtxt2 '..id..' 3 "255255255'..c2d_cet..'" 280 403')
		
			elseif (c2d_defense[id] == 1) then
				parse('hudtxt2 '..id..' 3 "000255000'..c2d_mat..'" 280 403')
	
			elseif (c2d_speed[id] == 1) then
				parse('hudtxt2 '..id..' 3 "000000255'..c2d_mspt..'" 280 403')

			elseif (c2d_strength[id] == 1) then
				parse('hudtxt2 '..id..' 3 "255000000'..c2d_mst..'" 280 403')

			elseif (c2d_mode[id] == 0) then
				parse('hudtxt2 '..id..' 3 "255255255Nanosuit V2 Online" 277 403')
			end

			if (player(id,"health") <= 0) then
				parse('hudtxt2 '..id..' 1 "255000000[ Nanosuit V2 Offline ]" 277 403')
				parse('hudtxt2 '..id..' 2 "255000000[ Nanosuit V2 Offline ]" 277 403')
				parse('hudtxt2 '..id..' 3 "255000000[ Nanosuit V2 Offline ]" 277 403')
			end	
		end
	end
end